"use strict";

const updatePeriode = 300;  // alle XXms Plot updaten
const ballR = 20;           // Ballradius

var startFlag = false;
var startTime = 0;
var updateTime = 0;
var t = [];
var x = [];
var y = [];
var vx = [];
var vy = [];

window.addEventListener('load', function()
{
    'use strict';
    function append(reset)
    {
        if (reset)
        {
            t = [];
            x = [];
            y = [];
        }
        t.push(engine.timing.timestamp / 1000.0);
        x.push(ball.position.x);
        y.push(500 - ballR - ball.position.y);
    }

    function update()
    {
        var update =
        {
            x: [t],
            y: [y]
        }
        Plotly.restyle(PLOT, update, [0]);
    }

    var engine = Matter.Engine.create({enableSleeping: false});
    var world = engine.world;
    var render = Matter.Render.create(
    {
        element: document.body,
        canvas: document.createElement('canvas'),
        engine: engine,
        options:
        {
            width: 500,
            height: 500,
            background: 'transparent',
            wireframes: false,
            showAngleIndicator: false
        }
    });
    
    render.canvas.width = 500;
    render.canvas.height = 500;
    document.getElementById('world').appendChild(render.canvas);

    // http://brm.io/matter-js/docs/classes/Body.html
    var ball = Matter.Bodies.circle(250, 250, 20,
    {
        density: 0.04,     // Dichte
        friction: 0.1,
        frictionAir: 0.1,   // Luftwiderstand
        restitution: 0.8,
        render:
        {
            fillStyle: '#F35e66',
            strokeStyle: 'black',
            lineWidth: 1
        }
    });

    Matter.World.add(world, ball);

    // Add a floor
    var floor = Matter.Bodies.rectangle(250, 520, 500, 40,
    {
        isStatic: true, // An immovable object
        render:
        {
            visible: false
        }
    });
    
    Matter.World.add(world, floor);

    // Make interactive
    var mouseConstraint = Matter.MouseConstraint.create(engine,
    {   //Create Constraint
        element: render.canvas,
        constraint:
        {
            render:
            {
                visible: true
            },
            stiffness:0.1
        }
    });

    Matter.World.add(world, mouseConstraint);
    
    Matter.Events.on(render, 'afterRender', function()
    {

    });

    // Start the engine
    Matter.Engine.run(engine);
    Matter.Render.run(render);
});
