"use strict";

var canvas_melibokus;
var ctx;
var height_canvas = 0;
var width_canvas = 0;
var frameRate  = 1 / 30;
var frameDelay = frameRate * 1000;  // Intervallzeit zum Zeichnen in ms
var g1, g2;
var isstatic = false;
var r = 15;
var timerID = -1;

// var y0 = 50;
// var scale =  1;
// var block = {y0: y0, y: 0, v: 0, mass: 0.8};                  // Block Position, Geschwindigkeit und Masse
// var wall  = {y0: 30, A:20, y: 30,  ly: 30, v: 0, t: 0, frequency: 0}; // Wand bzw. Anregung
// var Sy = 30;
// var Sx = 30;    // Größe der Masse
// var mouse = {x: 0, y: 0, isDown: false};

// Plot-Variablen
// var time = 0;
// var tt = [];
// var yy = [];
// var PLOT;
// const updatePeriode = 0.100;  // alle 0.1s Plot updaten
// var startFlag = true;
// var startTime = 0;
// var updateTime = 0;
// var vy = [];

var animation_setup = function()
{
    canvas_melibokus = document.getElementById('canvas_melibokus');
    ctx = canvas_melibokus.getContext('2d');  // 2d-Zeichenbereich

    document.getElementById('startbutton').onclick = function()
    {
        if (timerID != -1)
        {
            clearInterval(timerID);
        }
        
        g1 = {x0: width_canvas / 3, y0: height_canvas - r, y: height_canvas - r, v: 30, t0: 0.0, t: 0.0, color: 'orange'};
        g2 = {x0: 2 * width_canvas / 3, y0: height_canvas - r, y: height_canvas - r, v: 51, t0: 3.0, t: 0.0, color: 'blue'};
        timerID = setInterval(loop, frameDelay);
    };

    height_canvas = canvas_melibokus.height;
    width_canvas = canvas_melibokus.width;
    //console.log(width_canvas, height_canvas);

    g1 = {x0: width_canvas / 3, y0: height_canvas - r, y: height_canvas - r, v: 30, t0: 0.0, t: 0.0, color: 'orange'};
    g2 = {x0: 2 * width_canvas / 3, y0: height_canvas - r, y: height_canvas - r, v: 54, t0: 2.0, t: 0.0, color: 'blue'};
    
    ctx.clearRect(0, 0, width_canvas, height_canvas);
    ctx.save();
    
    draw(g1);
    draw(g2);

    // zeichnen
    function draw(pos)
    {
        ctx.strokeStyle = pos.color;
        ctx.fillStyle = pos.color;
        ctx.beginPath();

        ctx.moveTo(pos.x0 + r, pos.y);
        ctx.arc(pos.x0, pos.y, r, 0, Math.PI * 2, true); // Outer circle

        ctx.fill();
        ctx.stroke();
        
        ctx.fillStyle = 'black';
        ctx.font="10px Georgia";
        ctx.fillText("Alsbach", 2, height_canvas - 13);
        ctx.fillText("Melibokus", 2, 14);
        
        ctx.fillStyle = 'red';
        ctx.font="10px Georgia";
        ctx.fillText('Zeit: ' + String(Math.round(pos.t*25)) + 'min', width_canvas - 60, 14);
        
        ctx.fillStyle = 'white';
        ctx.font="10px Georgia";
        ctx.fillText(String(Math.round(pos.v / 10))+'km/h', pos.x0 - 13, pos.y + 2);
    }

    /*
    * loop() wird durch setInterval(loop, frameDelay) in animation_setup() periodisch aufgerufen
    */
    var loop = function()
    {   
        g1.t += frameRate;
        //console.log(g1.y, g2.y);
        if (g1.t - g1.t0 > 0)
        {
            g1.y = g1.y0 - g1.v * (g1.t - g1.t0);
        }

        //g1.y = g1.y0 - g1.v * ((g1.t - g1.t0) > 0 ? (g1.t - g1.t0) : 0);
        
        g2.t += frameRate;
        if (g2.t - g2.t0 > 0)
        {
            g2.y = g2.y0 - g2.v * (g2.t - g2.t0);
        }

        // canvas löschen und Zeichenenstellungen auf dem Stack speichern
        ctx.clearRect(0, 0, width_canvas, height_canvas);
        ctx.save();

        draw(g1);
        draw(g2);

        //if (!isstatic)
        //{
        //append(false);
        //}
        
        ctx.restore();
        if (g2.t * 25 > 180)
        {
            clearInterval(timerID);
        }
    };
};


//var setup = function()
//{
//var data = [
//{
//x: [],
//y: [],
//name: 'Position',
//mode: 'lines',
//line:
//{
//width: 1,
//dash: 'solid'
//}
//}]
//var layout =
//{
//xaxis:
//{
//autotick: true,
//title: 't in s',
//tickmode: 'linear',
//range: [0,30]
//},
//yaxis:
//{
//title: 'Position'
//}
//}
//PLOT = document.getElementById('plot');
//Plotly.plot(PLOT, data, layout);
//setInterval(loop, frameDelay);
// };

//function append(reset)
//{
//if (reset)
//{
//tt = [];
//yy = [];
//}
//tt.push(startTime);
//yy.push(-(block.y - wall.y - block.y0));
//if (tt[tt.length - 1] > 30 && typeof PLOT.layout.xaxis.autorange == 'undefined')
//{
//var update =
//{
//'xaxis.autorange': true
//};
//Plotly.relayout(PLOT, update);
//}
//}

//function update()
//{
//var update =
//{
//x: [tt],
//y: [yy]
//}
//Plotly.restyle(PLOT, update, [0]);
//}
